/* Header file used to define the monitor_env structure.  Included by both
   C and assembly code.

   The following macros should be defined before including this file:
    FIELD_S - define a 16-bit field
    FIELD_L - define a 32-bit field
    FIELD_END - define the end(size) of the structure.
  All fields must be properly aligned.  This is enforced in qvm86-host.c.
  If you get compiler errors involving __fixme_* symbols, you probably
  got something wrong in here.
  */
  
/* TODO: Put these in a sensible order (cosmetic).  */
/* Far pointer (offset32, segment16) */
#define FIELD_P(s, o, nl, ns) FIELD_L(s, o, nl) FIELD_S(s, o + 4, ns)
/* Descriptor table pointer (limit16, base32)  */
#define FIELD_D(s, o, ns, nl) FIELD_S(s, o, ns) FIELD_L(s, o + 2, nl)
  FIELD_P(host,	0,  eip, cs)
  FIELD_S(host,	6,  ds)
  FIELD_S(host,	8,  ldt)
  FIELD_D(host,	10, gdt_limit, gdt_base)
  FIELD_P(mon,	16, esp, ss)
  FIELD_S(host,	22, tr)
  FIELD_P(mon,	24, eip, cs)
  FIELD_S(mon,	30, tr)
  FIELD_L(mon,	32, cr0)
  /* TODO mon_cr2 is usused.  */
  FIELD_L(mon,	36, cr2)
  FIELD_L(mon,	40, cr3)
  FIELD_L(mon,	44, cr4)
  FIELD_L(host,	48, cr0)
  FIELD_L(host,	52, cr2)
  FIELD_L(host,	56, cr3)
  FIELD_L(host,	60, cr4)
  FIELD_S(mon,	64, linmap)
  FIELD_D(host,	66, idt_limit, idt_base)
  FIELD_S(,	72, pad1)
  FIELD_D(mon,	74, idt_limit, idt_base)
  FIELD_P(host,	80, esp, ss)
  FIELD_S(,	86, pad2)
  FIELD_S(mon,	88, ldt)
  FIELD_D(mon,	90, gdt_limit, gdt_base)
  FIELD_P(mon,	96, switch_eip, switch_cs)
  FIELD_S(mon,	102,switch_ds)
  FIELD_L(host,	104,switch_ptr)
  FIELD_L(host,	108,switch_pde_low)
  FIELD_L(mon,	112,switch_ptr)
  FIELD_L(host,	116,env)
  FIELD_L(mon,	120,reason)
  FIELD_L(mon,	124,errcode)
#if 0
  /* Linear address of the guest->host physical page mapping.  */
  FIELD_L(mon,	128,physmem_map)
  /* Address of the shadow page direcory.  */
  FIELD_L(mon,	132,shadow_pgd)
  /* Address of the guest page direcory.  */
  FIELD_L(mon,	136,guest_pgd)
  /* Linear address of shadow pagetables.  */
  FIELD_L(mon,	140,shadow_pte)
  /* Address of PTE for a free monitor page.  */
  FIELD_L(mon,	144,free_pte)
  /* Address of the free page.  */
  FIELD_L(mon,	148,free_page)
#else
  FIELD_L(mon,	128,_pad1)
  FIELD_L(mon,	132,_pad2)
  FIELD_L(mon,	136,_pad3)
  FIELD_L(mon,	140,_pad4)
  FIELD_L(mon,	144,_pad5)
  FIELD_L(mon,	148,_pad6)
#endif
  FIELD_L(host,	152,switch_pde_high)
  FIELD_L(host,	156,pae)
  FIELD_L(mon,	160,fault_count)
  FIELD_L(mon,	164,foo)
  FIELD_L(mon,	168,foo2)

  FIELD_END(172)

#undef FIELD_S
#undef FIELD_L
#undef FIELD_P
#undef FIELD_END
