/*
 * QVM86 virtualisation module for qemu
 *
 * Copyright (C) 2005 Filip Navara
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Windows kernel interfacing code.
 */

#ifndef QVM86_WIN32_H
#define QVM86_WIN32_H

#include <stddef.h>
#include <ddk/ntddk.h>

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;
typedef unsigned long long uint64_t;

#define asmlinkage

#define KERN_ERR "[ERROR] "
#define KERN_INFO "[INFO] "

#define printk DbgPrint
#define clear_page(addr) RtlZeroMemory((addr), PAGE_SIZE)
#define __get_user(dest, src) (dest) = *(src)
#define put_user(src, dest) *(dest) = (src)

extern int qvm86_host_pae;
#define host_physaddr_t uint64_t

#endif /* QVM86_WIN32_H */
